
old_PaperDollItemSlotButton_OnClick = PaperDollItemSlotButton_OnClick;

function PaperDollItemSlotButton_OnClick(button, ignoreShift)
	old_PaperDollItemSlotButton_OnClick(button, ignoreShift);
	if (this:GetName() == "CharacterBackSlot") then
		ToggleEquipView_ToggleCloak();
	elseif (this:GetName() == "CharacterHeadSlot") then
		ToggleEquipView_ToggleHelm();
	end
end

old_PaperDollItemSlotButton_Update = PaperDollItemSlotButton_Update;

function PaperDollItemSlotButton_Update(cooldown) 
	old_PaperDollItemSlotButton_Update(cooldown);
	UIOptionsFrame_Load();

	if (UIOptionsFrameCheckButtons["SHOW_HELM"].value == "1") then
		SetItemButtonNormalTextureVertexColor(CharacterHeadSlot, 0.0, 1.0, 0.0, 1.0);
	else
		SetItemButtonNormalTextureVertexColor(CharacterHeadSlot, 1.0, 0.0, 0.0, 1.0);
	end
	if (UIOptionsFrameCheckButtons["SHOW_CLOAK"].value == "1") then
		SetItemButtonNormalTextureVertexColor(CharacterBackSlot, 0.0, 1.0, 0.0, 1.0);
	else
		SetItemButtonNormalTextureVertexColor(CharacterBackSlot, 1.0, 0.0, 0.0, 1.0);
	end
end
	

function ToggleEquipView_SetHelmValue(value)
	UIOptionsFrame_Load();
	UIOptionsFrameCheckButtons["SHOW_HELM"].setFunc(value);
	UIOptionsFrameCheckButtons["SHOW_HELM"].func = function () return value end;
	UIOptionsFrameCheckButtons["SHOW_HELM"].value = value;
	UIOptionsFrameCheckButton31:SetChecked(value);
	UIOptionsFrame_Save();
	CharacterModelFrame:SetUnit("player");
end

function ToggleEquipView_SetCloakValue(value)
	UIOptionsFrame_Load();
	UIOptionsFrameCheckButtons["SHOW_CLOAK"].setFunc(value);
	UIOptionsFrameCheckButtons["SHOW_CLOAK"].func = function () return value end;
	UIOptionsFrameCheckButtons["SHOW_CLOAK"].value = value;
	UIOptionsFrameCheckButton30:SetChecked(value);
	UIOptionsFrame_Save();
	CharacterModelFrame:SetUnit("player");
end


function ToggleEquipView_ToggleCloak()
	ToggleEquipView_ToggleSlot("SHOW_CLOAK");
end

function ToggleEquipView_ToggleHelm()
	ToggleEquipView_ToggleSlot("SHOW_HELM");
end

function ToggleEquipView_ToggleSlot(slotName)
	if (UIOptionsFrameCheckButtons[slotName].value == "1") then
		SetItemButtonNormalTextureVertexColor(this, 1.0, 0.0, 0.0, 1.0);
		ToggleEquipView_SetHelmValue(0);
	else
		SetItemButtonNormalTextureVertexColor(this, 0.0, 1.0, 0.0, 1.0);
		ToggleEquipView_SetHelmValue(1);
	end
end


function ToggleEquipViewFrame_OnLoad()
	ToggleEquipViewFrame_RegisterSlashCommands();
end

function ToggleEquipViewFrame_RegisterSlashCommands()
	if ( Cosmos_RegisterChatCommand ) then
		local ToggleEquipView_CloakSlashCommand = {"/togglecloak","/tcloak"};
		Cosmos_RegisterChatCommand (
			"TOGGLEEQUIPVIEW_CLOAK_COMMANDS",
			ToggleEquipView_CloakCommands,
			ToggleEquipView_CloakSlashCommand,
			TOGGLEEQUIPVIEW_CHAT_CLOAK_COMMAND_INFO
		);
		local ToggleEquipView_HelmSlashCommand = {"/togglehelm","/thelm"};
		Cosmos_RegisterChatCommand (
			"TOGGLEEQUIPVIEW_HELM_COMMANDS",
			ToggleEquipView_HelmCommands,
			ToggleEquipView_HelmSlashCommand,
			TOGGLEEQUIPVIEW_CHAT_HELM_COMMAND_INFO
		);
	else
		SlashCmdList["TOGGLEEQUIPVIEWSLASHCLOAK"] = ToggleEquipView_CloakSlashCommand;
		SLASH_TOGGLEEQUIPVIEWSLASHCLOAK1 = "/togglecloak";
		SLASH_TOGGLEEQUIPVIEWSLASHCLOAK2 = "/tcloak";
		SlashCmdList["TOGGLEEQUIPVIEWSLASHHELM"] = ToggleEquipView_HelmSlashCommand;
		SLASH_TOGGLEEQUIPVIEWSLASHHELM1 = "/togglehelm";
		SLASH_TOGGLEEQUIPVIEWSLASHHELM2 = "/thelm";
	end
end


function ToggleEquipViewFrame_OnEvent(event)
	-- strictly for future development, if any is deemed necessary
end

function ToggleEquipView_CloakSlashCommand(cmd)
	ToggleEquipView_ToggleCloak();
end

function ToggleEquipView_HelmSlashCommand(cmd)
	ToggleEquipView_ToggleHelm();
end

